/*----------------------------------------------------------------------*
 *  All Rights Reserved, Copyright (C) FUJITSU LIMITED  1991-2010	*
 *----------------------------------------------------------------------*/
 
/**
 * 
 * xmʉGW ꏈCup API`t@C
 */

#ifndef LGPROC_INCLUDE
#define LGPROC_INCLUDE

#ifdef __cplusplus
extern "C" {
#endif

#ifndef LGPROCAPI
  /* Don't define "LGPROCDLL" symbol if you make apps. */
  #if defined(_WIN32) && defined(LGPROCDLL)
	#define LGPROCAPI	__declspec(dllexport)
  #elif defined(_WIN32) && !defined(_MP)
	#define LGPROCAPI	__declspec(dllimport)
  #else
	#define LGPROCAPI
  #endif
#endif

/*----------------------------------------------------------------------*
 *		^`															*
 *----------------------------------------------------------------------*/
#define MAX_OPTION_DIC_NUM		15
#define MAX_USER_DIC_NUM		15

typedef void * LNGHANDLE;

/* ꏈI[v\ */
typedef struct lngopen_tag
{
	char * pszSysDic;							/* {ꎫ */
	char * pszOptDic[MAX_OPTION_DIC_NUM];		/* IvV */
	char * pszUserDic[MAX_USER_DIC_NUM];		/* [U[ꎫ */
	unsigned long int dwCharSet;				/* R[hn */
	unsigned long int dwState;					/* AXe[^X */
} LNGOPEN;

/* ꏈ\ */
typedef struct lng_tag
{
	char * pszSrc;						/*  Ώە */
	char * pszDst;						/*   */
	unsigned short int wCnvMode;		/* ϊ[h */
	unsigned short int wReserved;		/* U[u */
	unsigned long int dwDstLength;		/* ͌ʂ̒ */
} LNG;

/* [U[ꎫANZX\ */
typedef struct lngudic_tag
{
	char * pszUdic;						/* [U[ꎫt@C */
	char * pszWrite;					/* \L */
	char * pszRead;						/* ǂݕ */
	unsigned short int wKind;			/* i */
	unsigned short int wReserved;		/* U[u */
} LNGUDIC;

/* [U[ꎫʍ\ */
typedef struct lngpickres_tag
{
	char *pszWrite;						/* \L */
	char *pszRead;						/* ǂݕ */
	unsigned short int wKind;			/* i */
	unsigned short int wReserved;		/* U[u */
} LNGPICKRES;

/* [U[ꎫ\ */
typedef struct lngpick_tag
{
	char * pszUdic;						/* [U[ꎫt@C */
	char * pszWrite;					/* \L */
	char * pszRead;						/* ǂݕ */
	unsigned short int wKind;			/* i */
	unsigned short int wReserved;		/* U[u */
	unsigned long int dwResultNum;		/* ʂ̐ */
	LNGPICKRES * pLngPickRes;			/*  */
} LNGPICK;

/* oE_ŕꂽeLXg𓾂\ */
#ifndef T_DIVIDED_TEXT_DEFINED
#define T_DIVIDED_TEXT_DEFINED
typedef struct tagTDividedText
{    
	char *pszNotation;					/* ꂽeLXg */
	unsigned long dwBoundaryKind;		/* oE_̎ */
	struct tagTDividedText *ptNext;		/* ̕ꂽeLXg */
} TDividedText;

/* oE_̎ */
#define FTTS_BOUNDARY_SENTENCE  1		/* ZeXoE_ */
#define FTTS_BOUNDARY_WORD      2		/* [hoE_ */
#endif	/* !defined(T_DIVIDED_TEXT_DEFINED) */

/*----------------------------------------------------------------------*
 *		G[R[h													*
 *----------------------------------------------------------------------*/
#define LNGERR_NOERR           (  0)	/* I */
#define LNGERR_UNKNOWN         ( -1)	/* m̃G[ */
#define LNGERR_INIT            ( -2)	/* orς */
#define LNGERR_NOMEM           ( -3)	/* s */
#define LNGERR_OPENFILE        ( -4)	/* ꎫI[vłȂ */
#define LNGERR_SYSDICFMRERR    (-24)	/* Wꎫ̌`G[ */
#define LNGERR_INVALUSERDIC    ( -5)	/* [Uꎫł͂Ȃ */
#define LNGERR_LARGEDIC        ( -6)	/* [UTCY傫 */
#define LNGERR_WRITESTRLEN     ( -7)	/* \L0܂254𒴂Ă */
#define LNGERR_READSTRLEN      ( -8)	/* ǂݒ384𒴂Ă */
#define LNGERR_WRITESTRFORM    ( -9)	/* \LُȏꍇAI~`łȂ */
#define LNGERR_MISMATCH        (-10)	/* \LƓǂ݂vĂȂ */
#define LNGERR_KIND            (-11)	/* i̎wɌ肪 */
#define LNGERR_ACCENTTOP       (-12)	/* ANZg擪ɃANZg */
#define LNGERR_ACCENTMULTI     (-13)	/* ANZgɕANZg */
#define LNGERR_NOTKANA         (-14)	/* ߂\킷J^JiłȂ */
#define LNGERR_CONSONANTTOP    (-15)	/* ANZg擪ɑ */
#define LNGERR_MACRONTOP       (-16)	/* ANZg擪ɒ */
#define LNGERR_CONSONANTMACRON (-17)	/* ̒ɒ */
#define LNGERR_WRITEFILE       (-18)	/* t@C݂̏Ɏs */
#define LNGERR_NOTFOUND        (-19)	/* w̒PꂪȂ */
#define LNGERR_ALREADYREG      (-20)	/* ̒Pꂪɓo^ */
#define LNGERR_INVALPARAM      (-21)	/* p[^[G[ */
#define LNGERR_ANALYZING       (-22)	/* ͏ */
#define LNGERR_CHGINGUSR       (-23)	/* [UꎫύX */

/* ϐČ݊p` */
#define LNGERR_READSTRFORM     LNGERR_WRITESTRFORM
#define LNGERR_MISSMUCH        LNGERR_MISMATCH

/* Convert Mode */
#define CNV_FIRST       1				/* pszSrc is first */
#define CNV_MIDDLE      2				/* pszSrc is middle */
#define CNV_LAST        3				/* pszSrc is last */

#define CNV_ONE			4				/* one by one */
#define CNV_ALL			5				/* all */

/* wKind : }Nl͕K1̘Alۂ */
#define K_MEI_SI		1				/* ʖ */
#define K_SEI			2				/*  */
#define K_MEI			3				/*  */
#define K_KOYU_MEISI	4				/* ŗL */
#define K_CHIMEI		5				/* n */
#define K_SAHEN_MEISI	6				/* Tϖ */
#define K_FUKU_SI		7				/*  */
#define K_RENTAI_SI		8				/* A̎ */
#define K_SETUZOKU_SI	9				/* ڑ */
#define K_KANDOU_SI		10				/*  */
#define K_GODAN_DOUSI	11				/* ܒi */
#define K_ICHIDAN_DOUSI	12				/* Ei */
#define K_SAHEN_DOUSI	13				/* TρEUϓ */
#define K_KEIYOU_SI		14				/* `e */
#define K_KEIYOU_DOUSI	15				/* `e */
#define K_KIGOU			16				/* ʋL */

#define LG_NUM_AUTO		1				/* [h */
#define LG_NUM_KETA		2				/* ǂ݃[h */
#define LG_NUM_BOU		3				/* _ǂ݃[h */

#define LG_SIGN_OFF		1				/* Lǂ܂Ȃ[h */
#define LG_SIGN_ON		2				/* Lǂރ[h */

#define LG_CODE_FJ		1				/* xmʃR[hn */
#define LG_CODE_MS		2				/* }CN\tgWLN^Zbg*/

#define LG_TEXTCMD_OFF	0				/* R}h[h */
#define LG_TEXTCMD_ON	1				/* R}hL[h */

#define LG_SPL_AUTO				 0		/*  */
#define LG_SPL_KUTEN		0x0001		/* _ */
#define LG_SPL_TOUTEN		0x0002		/* Ǔ_ */
#define LG_SPL_COMMA		0x0004		/* R} */
#define LG_SPL_PERIOD		0x0008		/* sIh */
#define LG_SPL_EXCLAMATION  0x0010		/* Q */
#define LG_SPL_QUESTION		0x0020		/* ^╄ */
#define LG_SPL_RETURN		0x0040		/* s */
#define LG_SPL_KEISEN		0x0080		/* r */

#define LG_SPL_PARANUM      0x0100      /* ͔ԍ؂ */
#define LG_SPL_ITEMIZE      0x0200      /* ӏ؂ */
#define LG_SPL_GAISU		0x0400		/* Ǔ_̊Tǂ݂ */
#define LG_SPL_ALL          0x03BF		/* ^[ȊȎS؂܂ */

#define LG_SPL_PIRIOD       LG_SPL_PERIOD		/* ݊̂ */

#define LG_ALPHA_ROMAN			1		/* [}ǂݗD惂[h */
#define LG_ALPHA_DIC			2		/* D惂[h */
#define LG_ALPHA_INTERCHANGE	3		/* ݊[h */

#define LG_LNSP_REMOVE			0x00	/* ɉs폜(]݊) */
#define LG_LNSP_HALF_ALNUM		0x01	/* pДpŋ(default) */
#define LG_LNSP_FULL_ALNUM		0x02	/* pSpŋ */

/* A铯L̐l */
#define LG_SIGN_NO_LIMIT		0		/* AL폜Ȃ(default) */
#define LG_SIGN_LIMIT			4		/* AL̐l4ɂB */

/* URLǂ݃[h */
#define LG_URL_OFF				0		/* URLǂݖ[h */
#define LG_URL_ON				1		/* URLǂݗL[h(default) */

/* tEEǂ݃[h (default:0x0F) */
#define LG_DT_TIME				0x01	/* ǂ݃[h */
#define LG_DT_DATE				0x02	/* tǂ݃[h */
#define LG_DT_BUNSU				0x04	/* ǂ݃[h */
#define LG_DT_NUM				0x08	/* t̐ǂ݉P */

/*----------------------------------------------------------------------*
 *		Function prototypes												*
 *----------------------------------------------------------------------*/

LGPROCAPI int LNG_analyzeInit( LNGHANDLE * phLNG, LNGOPEN * ptLngOpen );
LGPROCAPI int LNG_analyzeEnd( LNGHANDLE hLNG );
LGPROCAPI int LNG_analyze( LNGHANDLE hLNG, LNG * ptLng );
LGPROCAPI int LNG_analyzeEx( LNGHANDLE hLNG, LNG * ptLng, unsigned long dwOption, TDividedText * * pptDividedText );
LGPROCAPI int LNG_analyzeWithDPR( LNGHANDLE hLNG, LNG * ptLng, char **ppcDpResult );
LGPROCAPI int LNG_findAnalyzeUnit( LNGHANDLE hLNG, LNG * ptLng, unsigned short * pwNextLen );
LGPROCAPI int LNG_analyzeReset( LNGHANDLE hLNG );

LGPROCAPI int LNG_setNumeric( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getNumeric( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setSign( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getSign( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setSeparate( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getSeparate( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setTextCommand( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getTextCommand( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setAlphabet( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getAlphabet( LNGHANDLE hLNG, unsigned short *pnValue );

LGPROCAPI int LNG_setLineSpace( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getLineSpace( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setSignLimit( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getSignLimit( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setUrl( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getUrl( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setDateTime( LNGHANDLE hLNG, unsigned short nValue );
LGPROCAPI int LNG_getDateTime( LNGHANDLE hLNG, unsigned short *pnValue );
LGPROCAPI int LNG_setMode( LNGHANDLE hLNG, char *pszName, unsigned short nValue );
LGPROCAPI int LNG_getMode( LNGHANDLE hLNG, char *pszName, unsigned short *pnValue );

LGPROCAPI int LNG_changeUsrDic( LNGHANDLE hLNG, LNGOPEN *pLngOpen );
LGPROCAPI int LNG_registWord( LNGHANDLE hLNG, LNGUDIC *pLngUdic );
LGPROCAPI int LNG_eraseWord( LNGHANDLE hLNG, LNGUDIC *pLngUdic );
LGPROCAPI int LNG_pickupWord( LNGHANDLE hLNG, LNGPICK *pLngPick );
LGPROCAPI int LNG_checkWord( LNGUDIC *pLngUdic );

LGPROCAPI int LNG_LexiconAdd( LNGHANDLE hLNG, LNGUDIC *pLngUdic );
LGPROCAPI int LNG_LexiconDel( LNGHANDLE hLNG, LNGUDIC *pLngUdic );
LGPROCAPI int LNG_LexiconFind( LNGHANDLE hLNG, LNGPICK *pLngPick );
LGPROCAPI int LNG_LexiconLoad( LNGHANDLE hLNG, LNGPICK *pLngPick );

LGPROCAPI void LNG_freeMem( void *pvMem );
LGPROCAPI void LNG_freePickRes( LNGPICKRES *pLngPickRes );
LGPROCAPI void LNG_DividedTextFree( TDividedText *ptDividedText );
LGPROCAPI void LNG_DpResultFree( char *pcDpResult );

#ifdef __cplusplus
}
#endif
#endif	/* !LGPROC_INCLUDE */
