/*----------------------------------------------------------------------*
 *		All Rights Reserved, Copyright (C) FUJITSU LIMITED  1991-2010	*
 *----------------------------------------------------------------------*/

/**
 *
 * xmʉGW API֐wb_t@C
 */

#ifndef _INCLUDE_SYNTHE_H_
#define _INCLUDE_SYNTHE_H_

#ifdef __cplusplus
extern "C" {
#endif
/*****************************************************************************/

/**************/
/*   define   */
/**************/

#ifndef SYNTHEAPI
  /* Don't define "SYNTHEDLL" symbol if you make apps. */
  #if defined(_WIN32) && defined(SYNTHEDLL)
	#define SYNTHEAPI	__declspec(dllexport)
  #elif defined(_WIN32) && !defined(_MP)
	#define SYNTHEAPI	__declspec(dllimport)
  #else
	#define SYNTHEAPI
  #endif
#endif

/* g`̃nh */
typedef void * SYNHANDLE;

//////////////////////////////////////////////////////////////////////////////
// oE_ŕꂽeLXg𓾂\								//
//////////////////////////////////////////////////////////////////////////////
#ifndef T_DIVIDED_TEXT_DEFINED
#define T_DIVIDED_TEXT_DEFINED
typedef struct tagTDividedText
{    
	char *pszNotation;					/* ꂽeLXg */
	unsigned long dwBoundaryKind;		/* oE_̎ */
	struct tagTDividedText *ptNext;		/* ̕ꂽeLXg */
} TDividedText;

/* oE_̎ */
#define FTTS_BOUNDARY_SENTENCE  1		/* ZeXoE_ */
#define FTTS_BOUNDARY_WORD      2		/* [hoE_ */
#endif	/* T_DIVIDED_TEXT_DEFINED */

//////////////////////////////////////////////////////////////////////////////
// FTTS_PcmGenerate֐EFTTS_PcmGenerateFree֐Ŏgp郏[hEZe //
// XoE_i[\́B										//
//////////////////////////////////////////////////////////////////////////////
#ifndef T_BOUNDARY_INFO_DEFINED
#define T_BOUNDARY_INFO_DEFINED
typedef struct tagTBoundaryInfo
{
	unsigned long  dwWordBoundaryNum;			/* [hoE_̐ */
	unsigned long *pdwWordBoundaryOffset;		/* [hoE_ */
	unsigned long  dwSentenceBoundaryNum;		/* ZeXoE_̐ */
	unsigned long *pdwSentenceBoundaryOffset;	/* ZeXoE_ */
	unsigned long  dwPhonemeLenNum;				/* PhonemeԒ̐ */
	unsigned long *pdwPhonemeLenInfo;			/* PhonemeԒ */
	char          *pszPhonemeLenStr;			/* JEITA\ */
	TDividedText  *ptDividedText;				/* ꂽ{eLXg */
} TBoundaryInfo;
#endif	/* T_BOUNDARY_INFO_DEFINED */

/**
 * g`p[^ (CR[pX̊gp)
 */
typedef struct tagSYNTHEINIT
{
	unsigned int uiSize;						/**< ̍\̂̃TCY */
	const char *pszPrCpsDicName;				/**< CR[pX */
} TSyntheInit;

/**
 ** g`
 **/
#define SYT_WAVE_KIND_MALE		(0x0001)
#define SYT_WAVE_KIND_FEMALE	(0x0002)
#define SYT_WAVE_KIND_BOTH		(SYT_WAVE_KIND_MALE | SYT_WAVE_KIND_FEMALE)
#define SYT_WAVE_TYPE_FULLPITCH (0x8000)

/**
 ** g`
 **/
#define SYT_WAVE_DATA_8MLAW		(0)
#define SYT_WAVE_DATA_16LINEAR	(1)

/**
 ** Al
 **/
#define SYTRET_END             (  0)
#define SYTRET_CONTINUE        (  1)
#define SYTRET_NOTPLAY         (  0)
#define SYTRET_PLAY            ( +1)
#define SYTRET_PAUSE           ( +2)
#define SYTRET_GENERATE        ( +3)

#define SYTERR_NOERR           (  0)
#define SYTERR_INIT            ( -1)
#define SYTERR_BUSY            ( -2)
#define SYTERR_INVALPARAM      ( -3)
#define SYTERR_NOTSTARTED      ( -4)
#define SYTERR_NOMEM           ( -5)
#define SYTERR_NOQUEUE         ( -6)
#define SYTERR_WAVLIBERR       ( -7)
#define SYTERR_WDICFMRERROR    ( -8)
#define SYTERR_WDICSHAREERROR  ( -9)
#define SYTERR_INVALWDICNAME   (-10)
#define SYTERR_WAVNOTSUPPORTED (-11)
#define SYTERR_SEQUENCE        (-12)	/* V[PXG[ */
#define SYTERR_INVALMODE       (-13)	/* Cobh[h */

/* CR[pX */
#define SYTERR_INVALCPSDICNAME    (-20)
#define SYTERR_INVALCPSDICDATA    (-21)
#define SYTERR_INVALCPSDICTAG     (-22)
#define SYTERR_INVALCPSDICVERSION (-23)
#define SYTERR_CPSDICFSEEK		  (-24)
#define SYTERR_CPSDICFREAD		  (-25)
#define SYTERR_INVALCPSKEY		  (-26)
#define SYTERR_INVALCPSKEYDAT	  (-27)
#define SYTERR_INVALCPSDATA		  (-28)
#define SYTERR_INVALDAT			  (-29)
#define SYTERR_INTERNALPTERROR    (-30)

/* ͂ߍݍ */
#define SYTERR_OPENPHRASEDICFILE (-80)
#define SYTERR_ILLEGALPHRASEDIC  (-81)
#define SYTERR_PDICNOTSELECTED   (-82)
#define SYTERR_NODATA            (-83)
#define SYTERR_INVALBUNID        (-84)
#define SYTERR_PARAMTOOLONG      (-85)
#define SYTERR_PARAMTOOSHORT     (-86)
#define SYTERR_INVALCHAR         (-87)
#define SYTERR_CHARNOTFOUND      (-88)

/* 샂[h */
#define SYT_MODE_ORIGINAL (0)
#define SYT_MODE_SAPI5    (1)

//////////////////////////////////////////////////////////////////////////////
// ֐vg^Cv															//
//////////////////////////////////////////////////////////////////////////////
SYNTHEAPI SYNHANDLE SYT_syntheInit( const char *, unsigned int, unsigned int,
								int *, void * );
SYNTHEAPI int SYT_syntheEnd( SYNHANDLE );
SYNTHEAPI char * SYT_getParagraph( const char *, unsigned long *, unsigned long );

SYNTHEAPI int SYT_generatePcmStart( SYNHANDLE hSynth, const char * pcPhonBuff, unsigned long dwBuffSize );
SYNTHEAPI int SYT_generatePcm( SYNHANDLE hSynth, char * pcBuf, unsigned long dwBufSize, unsigned long * pdwGenerated );
SYNTHEAPI int SYT_generatePcmStop( SYNHANDLE );

SYNTHEAPI int SYT_PcmGenerateStart( SYNHANDLE hSynth, const char * pcPhonBuff, unsigned long dwBuffSize, TDividedText * ptDividedText );
SYNTHEAPI int SYT_PcmGenerate( SYNHANDLE hSynth, char * pcBuf, unsigned long dwBufSize, unsigned long * pdwGenerated, TBoundaryInfo * ptBoundaryInfo );
SYNTHEAPI int SYT_PcmGenerateStop( SYNHANDLE hSynth );
SYNTHEAPI void SYT_PcmGenerateFree( TBoundaryInfo * ptBoundaryInfo );

SYNTHEAPI int SYT_setVoiceType( SYNHANDLE, int );
SYNTHEAPI int SYT_setSpeedRate( SYNHANDLE, int );
SYNTHEAPI int SYT_setSpeed( SYNHANDLE, int );
SYNTHEAPI int SYT_setPitch( SYNHANDLE, int );
SYNTHEAPI int SYT_setVolume( SYNHANDLE, int );
SYNTHEAPI int SYT_setTone( SYNHANDLE, int );
SYNTHEAPI int SYT_setIntonation( SYNHANDLE, int );

SYNTHEAPI int SYT_getVoiceType( SYNHANDLE );
SYNTHEAPI int SYT_getSpeedRate( SYNHANDLE );
SYNTHEAPI int SYT_getSpeed( SYNHANDLE );
SYNTHEAPI int SYT_getPitch( SYNHANDLE );
SYNTHEAPI int SYT_getVolume( SYNHANDLE );
SYNTHEAPI int SYT_getTone( SYNHANDLE );
SYNTHEAPI int SYT_getIntonation( SYNHANDLE );

SYNTHEAPI int SYT_ModeSet( SYNHANDLE hSynth, int iValue );
SYNTHEAPI int SYT_ModeGet( SYNHANDLE hSynth, int * piValue );

SYNTHEAPI int SYT_SpeedSet( SYNHANDLE hSynth, int iValue );
SYNTHEAPI int SYT_SpeedGet( SYNHANDLE hSynth, int * piValue );

SYNTHEAPI int SYT_PitchSet( SYNHANDLE hSynth, int iValue );
SYNTHEAPI int SYT_PitchGet( SYNHANDLE hSynth, int * piValue );

SYNTHEAPI int SYT_EmphasisSet( SYNHANDLE hSynth, int iValue );
SYNTHEAPI int SYT_EmphasisGet( SYNHANDLE hSynth );

SYNTHEAPI int SYT_getSampleFreq( SYNHANDLE, unsigned long * );

/* ͂ߍݍ */
SYNTHEAPI int HMK_setPhraseDic(SYNHANDLE, const char *);
SYNTHEAPI int HMK_generatePcmStart(SYNHANDLE, unsigned long, const char *, unsigned long);
SYNTHEAPI int HMK_generatePcm(SYNHANDLE, char *, unsigned long, unsigned long *);
SYNTHEAPI int HMK_generatePcmStop(SYNHANDLE);
SYNTHEAPI int HMK_checkParam(SYNHANDLE, unsigned long, const char *, unsigned long);

/* ݊̂߂ɒ`c (ԂԈႢ̃}N萔) */
#define STY_WAVE_KIND_MALE		SYT_WAVE_KIND_MALE
#define STY_WAVE_KIND_FEMALE	SYT_WAVE_KIND_FEMALE
#define STY_WAVE_KIND_BOTH		SYT_WAVE_KIND_BOTH
#define STY_WAVE_TYPE_FULLPITCH	SYT_WAVE_TYPE_FULLPITCH	
#define STY_WAVE_DATA_8MLAW		SYT_WAVE_DATA_8MLAW
#define STY_WAVE_DATA_16LINEAR	SYT_WAVE_DATA_16LINEAR

/* Ssb`ł̌݊pɒǉ (ogpȂ) */
#define SYRET_END               SYTRET_END
#define SYRET_CONTINUE          SYTRET_CONTINUE
#define SYRET_NOTPLAY           SYTRET_NOTPLAY
#define SYRET_PLAY              SYTRET_PLAY
#define SYRET_PAUSE             SYTRET_PAUSE
#define SYRET_GENERATE          SYTRET_GENERATE

#define SYERR_NOERROR           SYTERR_NOERR
#define SYERR_INIT              SYTERR_INIT
#define SYERR_BUSY              SYTERR_BUSY
#define SYERR_INVALPARAM        SYTERR_INVALPARAM
#define SYERR_NOTSTARTED        SYTERR_NOTSTARTED
#define SYERR_NOMEM             SYTERR_NOMEM
#define SYERR_NOQUEUE           SYTERR_NOQUEUE
#define SYERR_WAVLIBERR         SYTERR_WAVLIBERR
#define SYERR_WDICFMRERROR      SYTERR_WDICFMRERROR
#define SYERR_WDICSHAREERROR    SYTERR_WDICSHAREERROR
#define SYERR_INVALWDICNAME     SYTERR_INVALWDICNAME
#define SYERR_WAVNOTSUPPORTED   SYTERR_WAVNOTSUPPORTED

#define SYERR_INVALCPSDICNAME    SYTERR_INVALCPSDICNAME
#define SYERR_INVALCPSDICDATA    SYTERR_INVALCPSDICDATA
#define SYERR_INVALCPSDICTAG     SYTERR_INVALCPSDICTAG
#define SYERR_INVALCPSDICVERSION SYTERR_INVALCPSDICVERSION
#define SYERR_CPSDICFSEEK		 SYTERR_CPSDICFSEEK
#define SYERR_CPSDICFREAD		 SYTERR_CPSDICFREAD
#define SYERR_INVALCPSKEY		 SYTERR_INVALCPSKEY
#define SYERR_INVALCPSKEYDAT	 SYTERR_INVALCPSKEYDAT
#define SYERR_INVALCPSDATA		 SYTERR_INVALCPSDATA
#define SYERR_INVALDAT			 SYTERR_INVALDAT
#define SYERR_INTERNALPTERROR    SYTERR_INTERNALPTERROR

#define SYERR_OPENPHRASEDICFILE SYTERR_OPENPHRASEDICFILE
#define SYERR_ILLEGALPHRASEDIC  SYTERR_ILLEGALPHRASEDIC
#define SYERR_PDICNOTSELECTED   SYTERR_PDICNOTSELECTED
#define SYERR_NODATA            SYTERR_NODATA

/*****************************************************************************/
#ifdef __cplusplus
}
#endif

#endif	/* _INCLUDE_SYNTHE_H_ */
