/*----------------------------------------------------------------------*
 *      All Rights Reserved, Copyright (C) FUJITSU LIMITED  2011-2011   *
 *----------------------------------------------------------------------*/
/**
 * @file    FttsLibUtilities.h
 * @brief   音声合成用のヘルパー関数の宣言
 * @author  Y.Teramoto
 * @date    2011/09/30
 */

#import <Foundation/Foundation.h>

#import "FttsLngHandle.h"
#import "FttsSynHandle.h"

extern FttsLngHandle *GetLngHandle(void);
extern FttsSynHandle *GetSynHandle(void);

extern NSDictionary *GetParamDict(void);
extern NSDictionary *GetInitPropDict(void);

extern NSStringEncoding GetParamEncoding(void);

extern char *GetResourcePath(NSString *fileName);
extern char *GetCopiedResourcePath(NSString *fileName);

extern void InitLngProp(void);
extern void InitSynProp(void);

extern NSArray *GetTextArray(void);
extern void AppendTextArray(NSString *text);

extern int numericValueToPosit(int value);
extern int alphabetValueToPosit(int value);
extern BOOL signValueToState(int value);
extern BOOL textCommandValueToState(int value);

extern int numericPositToValue(int posit);
extern int alphabetPositToValue(int posit);
extern int signStateToValue(BOOL state);
extern int textCommandStateToValue(BOOL state);

/* vim:set tabstop=4  : */
