/*----------------------------------------------------------------------*
 *      All Rights Reserved, Copyright (C) FUJITSU LIMITED  2011-2011   *
 *----------------------------------------------------------------------*/
/**
 * @file    FttsSynHandle.h
 * @brief   音響処理部のハンドルクラス宣言
 * @author  Y.Teramoto
 * @date    2011/09/30
 */


#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>
#include "FttsLib/synthe.h"

/*!
 * @class FttsSynHandle
 * @brief 音声合成音響処理部のハンドルクラス
 */
@interface FttsSynHandle : NSObject {
	SYNHANDLE m_hSynth;
	AudioQueueRef mAudioQueue;
}

- (BOOL)prepareHandle;
- (void)releaseHandle;

- (void)speak:(NSString *)phonStr;

- (BOOL)isSynthesizing;
- (void)stopWithImmediate:(BOOL)inImmediate;

@end
/* vim:set tabstop=4 : */
